import { Parenthesis } from "../parser/ast";
/**
 * Bookkeeper for inline blocks.
 *
 * Inline blocks are parenthesised expressions that are shorter than INLINE_MAX_LENGTH.
 * These blocks are formatted on a single line, unlike longer parenthesised
 * expressions where open-parenthesis causes newline and increase of indentation.
 */
export default class InlineBlock {
    private expressionWidth;
    constructor(expressionWidth: number);
    /**
     * Check if this should be an inline parentheses block
     * Examples are "NOW()", "COUNT(*)", "int(10)", key(`somecolumn`), DECIMAL(7,2)
     */
    isInlineBlock(parenthesis: Parenthesis): boolean;
    private inlineWidth;
    private betweenWidth;
    private isForbiddenToken;
}
