import { type Token } from '../lexer/token';
export declare type ParamItems = {
    [k: string]: string;
};
/**
 * Handles placeholder replacement with given params.
 */
export default class Params {
    /**
     * @param {ParamItems} params
     */
    params: ParamItems | string[] | undefined;
    index: number;
    constructor(params: ParamItems | string[] | undefined);
    /**
     * Returns param value that matches given placeholder with param key.
     * @param {Token} token
     * @return {string} param or token.text when params are missing
     */
    get({ key, text }: Token): string;
}
